<template>
  <a-layout>
    <a-layout-content style="padding: 0;">
      <a-card class="box-card" style="flex: 1; overflow-y: auto; padding: 0 !important;">
        <pblm-query-terms ref="queryTerms" :showRectifyStatus="false" :showZgXianOrgId="false" @queryByParams="queryByParams" />
        <a-row type="flex" justify="space-between" style="border-top:1px solid #0014ff2e;">
          <a-col :span="24" class="el-row-operation">
            <a-button
              @click="openActivityCommentDialog(1, $event)"
              :disabled="loading"
              size="small"
              type="primary"
              style="color:rgba(255,255,255,1);float:left;margin-right:10px;">送复核</a-button>
            <a-button
              @click="openMonthlyReportDialog(1, $event)"
              :disabled="loading"
              size="small"
              type="primary"
              style="color:rgba(255,255,255,1);float:left;margin-right:10px;">上报整改进度</a-button>
            <a-button
              @click="downloadMonthlyReportExcelTemplate()"
              :disabled="loading"
              size="small"
              type="primary"
              style="color:rgba(255,255,255,1);float:left;margin-right:10px;">下载整改进度月报模板</a-button>
            <a-button
              @click="setBatchXh"
              :disabled="loading"
              size="small"
              type="primary"
              style="color:rgba(255,255,255,1);float:left;margin-right:10px;">归档销号</a-button>
          </a-col>
        </a-row>
        <pblm-table
          ref="xjdwPblmTable"
          :pblmTableSetting="xjdwUnderRectifyTableSetting"
          @pageChange="handlePageChange"
          @sizeChange="handleSizeChange"
          @query="resetQuery"
          @selectionChange="handleSelectionChange" />
        <activity-comment
          v-if="showActivityCommentDialog"
          :isAg="this.isAg"
          :activityName="this.actName"
          @saveActivityComment="saveActivityComment"
          @closeActivityCommentDialog="closeActivityCommentDialog" />
        <monthly-report-comment
          v-if="showMonthlyReportCommentDialog"
          :isAg="this.isAg"
          :activityName="this.actName"
          @saveMonthlyReportComment="saveMonthlyReportComment"
          @closeMonthlyReportCommentDialog="closeMonthlyReportCommentDialog" />
      </a-card>
    </a-layout-content>
  </a-layout>
</template>

<script>
import moment from 'moment';
import request from '../../utils/gw_ajax_request';
import { formatDateTime2 } from '../../utils/gw_date';
import { exportModel } from '../../utils/gw_exportModel';
import MonthlyReportComment from '../PblmRectifyMonthlyReport/Components/MonthlyReportComment.vue';
import {
  approvedPblmRectify,
  formatPblms,
  requestUnderRectifyPblm,
} from './Common/rectify_api';
import { formatDeadLineDate } from './Common/rectify_date';
import ActivityComment from './Components/ActivityComment.vue';
import pblmQueryTerms from './Components/pblmQueryTerms';
import pblmTable from './Components/pblmTable';
export default {
  name: 'XjdwUnderRectifyPblm',
  props: [],
  components: {
    pblmQueryTerms,
    pblmTable,
    ActivityComment,
    MonthlyReportComment,
  },
  data() {
    return {
      moment,
      underRectifyPblm: [], // 待下发问题列表
      loading: false,
      currentWorkflowStat: '22', // 整改状态 22=县级单位整改中的问题
      queryParams: {
        hasVedio: '',
        adCode: '',
        pblmStat: '',
        inspPblmCate: '',
        ifCasePblm: '',
        nm: '',
        rsName: '',
        adFullName: '',
        startTime: '',
        endTime: '',
        objType: '', // 为空才能不区分督查类别
        inspPblmName: '',
        dataStat: '2', // 整改阶段必须为2
        persId: localStorage.getItem('persId'),
        villType: '0',
        pageSize: 10,
        pageNum: 1,
        pblmTotal: 0,
        pTypeCode: '', // 督查类别
        pYear: '', // 年度
        zgXianOrgId: null, // 接收单位
        zgWh: '', // 整改文号
        workflowStat: '',
        schdYear: moment(new Date().getFullYear().toString()).format('YYYY'),
      },
      xjdwUnderRectifyTableSetting: {
        adType: false,
        currentFllow: '22',
        cType: '1',
        data: [], // 主数据源
        pagination: {
          pageSize: 10,
          pageNum: 1,
          pblmCount: 0,
        }, // 翻页相关配置项
        height: 500,
        currentPblmId: '', // 当前选中的问题的ID
        selectedPblms: {}, // 多选模式下选中的所有问题集合
        multiSelect: true, // 是否出现行复选框
        enablePblmRectifyInfo: true, // 操作栏是否有整改信息输入按钮
        enableMonthlyReport: false, // 操作栏显示整改进度月报输入按钮
        isZGZWTBtn: true, // 是否是整改中问题 整改中问题 查看详情 附件可以删除
        ifChao: true,
      },
      showActivityCommentDialog: false,
      showMonthlyReportCommentDialog: false,
      isAg: 1,
      actName: '', // 流程流转方向名称
    };
  },
  created() {
    this.queryParams.workflowStat = this.currentWorkflowStat; // important 使用当前流程状态码来获取对应的问题列表
    this.getUnderRectifyPblm();
  },
  mounted() {
    this.$nextTick(function () {
      this.xjdwUnderRectifyTableSetting.height =
        document.getElementsByClassName('ant-tabs')[0].offsetHeight - 260;
    });
  },
  computed: {
    formatDateTime() {
      return formatDateTime2;
    },
    formatDeadLineDate() {
      return formatDeadLineDate;
    },
  },
  methods: {
    // 按指定条件获取待下发问题列表数据
    resetQuery() {
      console.log(111);
      this.getUnderRectifyPblm();
    },
    queryByParams(val) {
      this.queryParams = val.queryParams;
      this.queryParams.workflowStat = this.currentWorkflowStat;
      this.$refs.xjdwPblmTable.clearSelection(); // 清空问题列表子组件中原有的选中的行
      this.getUnderRectifyPblm();
    },
    // 获取待下发问题列表数据
    getUnderRectifyPblm() {
      this.loading = true;
      this.queryParams.pageSize =
        this.xjdwUnderRectifyTableSetting.pagination.pageSize;
      this.queryParams.pageNum =
        this.xjdwUnderRectifyTableSetting.pagination.pageNum;
      requestUnderRectifyPblm(this.queryParams).then((res) => {
        this.loading = false;
        if (res.data !== null) {
          this.xjdwUnderRectifyTableSetting.data = res.data.list;
          /* this.xjdwUnderRectifyTableSetting.data.sort(function (x, y) {
             return x.zgDate - y.zgDate;
           }); */
          this.xjdwUnderRectifyTableSetting.pagination.pblmCount =
            res.data.total;
        } else {
          this.xjdwUnderRectifyTableSetting.data = [];
          this.xjdwUnderRectifyTableSetting.pagination.pblmCount = 0;
        }
      });
    },
    // 直接页数跳转
    handlePageChange(val) {
      this.xjdwUnderRectifyTableSetting.pagination.pageNum = val.pageNum;
      this.getUnderRectifyPblm();
    },
    // 调整每页显示记录数
    handleSizeChange(val) {
      this.xjdwUnderRectifyTableSetting.pagination.pageSize = val.pageSize;
      this.getUnderRectifyPblm();
    },
    // 选中行时获取所有已选中行
    handleSelectionChange(val) {
      this.xjdwUnderRectifyTableSetting.selectedPblms = val.selectedPblms;
    },
    openActivityCommentDialog(isAg, e) {
      if (this.xjdwUnderRectifyTableSetting.selectedPblms.length > 0) {
        this.isAg = isAg;
        this.actName = e.currentTarget.innerText;
        this.showActivityCommentDialog = true;
      } else {
        this.$message.warning('请选择需要操作的问题!');
      }
    },
    openMonthlyReportDialog(isAg, e) {
      this.isAg = isAg;
      this.actName = e.currentTarget.innerText;
      this.showMonthlyReportCommentDialog = true;
    },

    closeActivityCommentDialog() {
      this.showActivityCommentDialog = false;
    },
    saveActivityComment(val) {
      this.closeActivityCommentDialog();
      this.approveSelectedPblm(val.isAg, val.Comment);
    },
    closeMonthlyReportCommentDialog() {
      this.showMonthlyReportCommentDialog = false;
    },
    saveMonthlyReportComment(val) {
      this.closeMonthlyReportCommentDialog();
      this.SubmitMonthlyReportForSelectedPblm(
        val.isAg,
        val.Comment,
        val.fileExt,
        val.filePath,
      );
    },
    // 驱动整改流程流转
    approveSelectedPblm(isAg, activityComment) {
      if (this.xjdwUnderRectifyTableSetting.selectedPblms.length > 0) {
        this.loading = true;
        approvedPblmRectify(
          formatPblms(
            this.xjdwUnderRectifyTableSetting.selectedPblms,
            isAg,
            activityComment,
          ),
        ).then((res) => {
          this.loading = false;
          if (res.success) {
            this.$message.success('操作已完成!');
            this.$refs.xjdwPblmTable.clearSelection(); // 清空原有的选中行信息
            this.getUnderRectifyPblm();
          } else {
            this.$message.error(res.message);
          }
        });
      } else {
        this.$message.warning('请选择需要操作的问题!');
      }
    },
    // 上报整改进度月报
    SubmitMonthlyReportForSelectedPblm(
      isAg,
      activityComment,
      fileExt,
      filePath,
    ) {
      // if (this.xjdwUnderRectifyTableSetting.selectedPblms.length > 0) {
      //   this.loading = true;

      // PblmRectifyMontlyReport(formatPblms(this.xjdwUnderRectifyTableSetting.selectedPblms, isAg, activityComment)).then(res => {
      //   this.loading = false;
      //   this.$message.success("操作已完成!");
      //   this.$refs.xjdwPblmTable.clearSelection();  //清空原有的选中行信息
      //   this.getUnderRectifyPblm();
      // })
      // } else {
      //   this.$message.warning("请选择需要操作的问题!");
      // }
      const data = {
        fileName: filePath,
        persId: localStorage.getItem('persId'),
        persName: localStorage.getItem('account1'),
      };
      request.post('/dc/insp/pblm/insertXls', data).then((res) => {
        if (res.data.type) {
          this.$message.error('当前文件不存在！');
        } else {
          this.$message.success(
            '成功:' + res.data.success + '条,失败:' + res.data.false + '条',
          );
        }
      });
    },
    async downloadMonthlyReportExcelTemplate() {
      const datas = JSON.stringify(this.queryParams);
      const url =
        '/modular-source/6ace62b8e2bb467d98286d260aebcef2/pdcApi/dc/insp/pblm/page/rever/exportxian';
      const type = 'post';
      const exportName = '整改进度月报模板.xls';
      const result = await exportModel(type, url, exportName, datas);
    },
    setBatchXh() {
      const params = [];
      if (
        JSON.stringify(this.xjdwUnderRectifyTableSetting.selectedPblms) !== '{}'
      ) {
        this.xjdwUnderRectifyTableSetting.selectedPblms.forEach((item) => {
          const obj = {
            isPdSche: item.isPdSche,
            pblmId: item.pblmId,
          };
          params.push(obj);
        });
        request.post('/bis/insp/zg/pblm/setBatchXh', params).then((res) => {
          if (res.success) {
            this.$message.success('归档销号成功!');
            this.getUnderRectifyPblm();
          } else {
            this.$message.error(res.message);
          }
        });
      } else {
        this.$message.info('请选择!');
      }
    },
  },
};
</script>

<style lang='less' scoped>

</style>
